openerp.eiru_websocket_engine = function (instance, local) {
    var Socket = io;
    var QWeb = instance.web.qweb;

    local.ChatWidget = instance.Widget.extend({
        template: 'ChatTemplate',
        messages: [],
        events: {
            'keyup .input-chat': 'send_handler'
        },
        start: function () {
            this.socket = Socket();
            this.socket.on('connect', function (greet) {
                console.log(greet);
            });
            this.receive_handler();
        },
        send_handler: function (e) {
            if (e.keyCode != 13) {
                return;
            }

            var message = $(e.target).val();
            $(e.target).val('')
            
            this.messages.push(message);
            this.socket.emit('message', message);
            this.messages_changed();
        },
        receive_handler: function () {
            var self = this;

            this.socket.on('message', function (message) {
                self.messages.push(message);
                self.messages_changed();
            });
        },
        messages_changed: function () {
            this.$el.find('.messages-chat').html('');
            for (var i = 0; i < this.messages.length; i++) {
                this.$el.find('.messages-chat').append(QWeb.render('MessageTemplate', { data: this.messages[i] }));
            }
        }
    });

    instance.web.client_actions.add('eiru_websocket_engine.chat', 'instance.eiru_websocket_engine.ChatWidget');
}